<?php if(!defined('IS_CMS')) die();

/***************************************************************
 *
* Plugin fuer moziloCMS, welches beim Aufruf nicht vorhandener Seiten einen 404 Error liefert
* by -FuFu- mit viel Hilfe von stefanbe
*    Migration nach 2.0 black-night - Daniel Neef
*
***************************************************************/

class Error404 extends Plugin {

    function getContent($value) {
        global $CatPage;
        $CAT_REQUEST_URL = $CatPage->get_UrlCoded(getRequestValue('cat', 'get'));
        $PAGE_REQUEST_URL = $CatPage->get_UrlCoded(getRequestValue('page', 'get'));

        # Debug Ausgabe
        #echo $CAT_REQUEST_URL."<br />\n";
        #echo $PAGE_REQUEST_URL."<br />\n";
        #echo CAT_REQUEST."<br />\n";
        #echo PAGE_REQUEST."<br />\n";
        	
        # prüft ob Seite existiert
        if(empty($CAT_REQUEST_URL))
            return null;
        if(empty($PAGE_REQUEST_URL) and $CAT_REQUEST_URL == CAT_REQUEST)
            return null;
        if($PAGE_REQUEST_URL == PAGE_REQUEST and $CAT_REQUEST_URL == CAT_REQUEST)
            return null;
        if(($CAT_REQUEST_URL == "inde") or ($PAGE_REQUEST_URL == "index.php") or ($CAT_REQUEST_URL == "index.php"))
            return null;

        # status code setzen/senden
        header("HTTP/1.0 404 Not Found");
        header("Status: 404 Not Found");

        global $syntax;
        # prüfen, ob der Plugin Platzhalter ein Parameter mitbekommen hat
        # {Error404} kein Parameter
        if(!$value) {
            $error_page = false;
            # steht in dem Inputfeld eine gültige Datei. Das Inputfeld hat Vorrang.
            if(is_file(BASE_DIR.$this->settings->get("ownSide")))
                $error_page = BASE_DIR.$this->settings->get("ownSide");
            # wurde in der Selectbox eine Datei ausgewählt
            elseif(is_file($this->settings->get("error_page_select")))
            $error_page = $this->settings->get("error_page_select");
            else
                $error_page = BASE_DIR.PLUGIN_DIR_NAME."/Error404/default.htm";
            	
            # es gibt eine gültige Datei
            if($error_page and is_readable($error_page)) {
                # $error_page mit dem Inhalt der Datei füllen
                $error_page = file_get_contents($error_page);
                $syntax->content = $error_page;
                #echo "Errorpage= ".$error_page;
            }
            return null;
        }
        # {Error404| error Inhalt } mit Parameter        
        list($content_first,$content,$content_last) = $syntax->splitContent();
        $syntax->content = $content_first.$value.$content_last;
        return null;
    }

    /***************************************************************
    * 
    * Gibt die Konfigurationsoptionen als Array zurück.
    * 
    ***************************************************************/
    function getConfig() {
        # alle seiten, die im Plugin sind und mit .html oder .htm zur Auswahl anbieten
        $error_pages = array("keine" => "keine ausgewählt");
        foreach(getDirAsArray(PLUGIN_DIR_REL."/Error404",array(".htm",".html")) as $page) {
            # array erstellen damit in der selectbox der name der datei steht und als parameter der komplette pfad incl. datei.
            $error_pages[PLUGIN_DIR_REL."/Error404/".$page] = $page;
        }
		
		$config = array();
        
		$config['error_page_select'] = array(
            "type" => "select",
            "description" => "Hier kannst Du eine Fehlerseite aus dem Plugin-Ordner auswählen",
            "descriptions" => $error_pages,
            "multiple" => "false"
            );
		
		 $config['ownSide'] = array(
            "type" => "text",
            "description" => "oder Du gibst hier eine Fehlerseite ein."
        );
        
         return $config;
    } // function getConfig
    function getInfo() {
		$info = array(
            // Plugin-Name
            "<b>Own Error Page</b> Version 0.4",
            // CMS-Version
            "2.0",
            // Kurzbeschreibung
            'Eigene Fehlerseite einstellen.<br />
			<br />
            <span style="font-weight:bold;">Wichtig:</span><br />
            Eigene Fehlerseiten können entweder in den Plugin-Ordner 
			geladen werden oder man gibt den Pfad zur Fehlerseite selbst an. <br />
			Pfad relativ zur Adresse eingeben, aus www.deine-domain.de/404.htm wird /404.htm<br />
			Wird keine Seite in der Selectbox gewählt und auch keine eigene Seite angegeben, 
			wird automatisch die default.htm aus dem Pluginordner verwendet. Die default.htm wird ebenso 
			verwendet, wenn eine nicht vorhandene Seite eingegeben wird.<br />
			 <span style="font-weight:bold;">Nutzung:</span><br />
			{Error404} am besten in das Template direkt vor /head einbinden!<br />
			Alternativ kann man {Error404} auch in die default Inhaltsseite einbinden.<br />
			Es besteht auch die Möglichkeit, einen kurzen Text zu nutzen. Dazu verwendest Du den Syntax wie folgt: <br />
			{Error404|Hier der Text, der angezeigt werden soll}.',
            // Name des Autors
            "-FuFu- mit viel Hilfe von stefanbe<br />Migration nach 2.0 by black-night - Daniel Neef",
            // Download-URL
            "https://www.mozilo.de",
            array(
                '{Error404}' => 'Am besten in das Template einbinden')
            );
            return $info;
    }
	

} // class

?>