<?php
/*************************************************************************
*
* FlayrPlayer-Plugin für moziloCMS.
* FlayrPlayer-Dateien von http://www.flayr.net/
*
* 
* History:
*
* Ref. 154 - 06.05.2011
*   Tag <embed ... > entfernt da dies nicht xhtml valide ist.
*   Siehe dazu: http://www.mozilo.de/forum/index.php/topic,1613.msg10270.html#msg10270
*
* Ref. 155 - 06.04.2013
*   Tag <param name="wmode" value="opaque" /> ergänzt damit Player "unter" mit css
*   fixierten, zB horizontalen Menübars bleibt. Danke an wasp für die Recherche!
*
**************************************************************************/

class FlayrPlayer extends Plugin {
    
    function getContent($value) {
        global $CMS_CONF;
        global $specialchars;

        # width vorbereiten
        $width = 320; # Fallback
        if($this->settings->get("defaultWidth"))
            $width = str_replace("px", "", $this->settings->get("defaultWidth"));

        # height vorbereiten
        $height = 240; # Fallback
        if ($this->settings->get("defaultHeight"))
            $height = str_replace("px", "", $this->settings->get("defaultHeight"));

        $movie = false;
        $img = false;

        $values = explode(",", $value);

        $para = array("movie" => "file", "img" => "file", "width" => "digit", "height" => "digit");
        $pos = 0;
        foreach($para as $vari => $type) {
            if(isset($values[$pos])) {
                $test = str_replace(array("%","px"),"",strtolower($values[$pos]));
                # ist keine zahl und type = file
                if(!ctype_digit($test) and $type == "file") {
                    ${$vari} = $this->FlayrPlayerMovieImg($values[$pos],$vari);
                    $pos++;
                # ist eine zahl und type = digit
                } elseif(ctype_digit($test) and $type == "digit") {
                    # beim object ist nur zahl oder zahl% erlaubt
                    ${$vari} = str_replace("px","",strtolower($values[$pos]));
                    $pos++;
                }
            }
        }

        $player = URL_BASE.PLUGIN_DIR_NAME."/FlayrPlayer/flayrplayer.swf";
        $playerskin = $this->settings->get("skin");
        $skinfile = URL_BASE.PLUGIN_DIR_NAME."/FlayrPlayer/skin_".$playerskin.".png";

        # Gesamthöhe = Clip + PlayerBar (25px), wenn Höhe % dann nicht rechnen
        if (strpos($height, "%") === false) {
            $height = $height + 25;
        }

        $dataStr = $player ."?movie=" .$movie. "&amp;controls=show&amp;preview=". $img ."&amp;buffer=false&amp;";
        
        switch ($playerskin) {
        case "glass":
            $dataStr .= "theme=".$skinfile;
            break;

        case "black":
            $dataStr .= "color_controls=#ffffff&amp;color_buffer=#ffffff&amp;alpha_buffer=10&amp;theme=".$skinfile; 
            break;
    
        case "corner":
            $dataStr .= "color_buffer=#ffffff&amp;alpha_buffer=30&amp;theme=".$skinfile;
            break;

        case "round":
            $dataStr .= "color_buffer=#ffffff&amp;alpha_buffer=60&amp;theme=".$skinfile;
            break;

        default:
            # no skin or empty
            break;
        }

        # HMTL-Output erstellen
        $html  = '<div class="flayrplayer_div">' ."\n";
        $html .= '<object class="flayrplayer_object" type="application/x-shockwave-flash" data="'.$dataStr.'" width="'.$width.'" height="'.$height.'">' ."\n";
        $html .= '  <param name="movie" value="'.$dataStr.'" />'. "\n";
        $html .= '  <param name="wmode" value="opaque" />'. "\n";
        $html .= '  <param name="allowscriptaccess" value="always" />'. "\n";
        $html .= '  <param name="allowfullscreen" value="true" />'. "\n";
        $html .= "</object></div>";

        return $html;
    } // function getContent
    

    function FlayrPlayerMovieImg($para,$vari) {
        global $CatPage;
        
        if(strtolower(substr($para,0,7)) == "http://" or strtolower(substr($para,0,8)) == "https://") {
            # externer Link, 1:1 übernehmen
            return stripslashes($para);
        } else {
            $alowed_movie = array(".flv",".f4v",".mp4");
            $alowed_img = array(".png",".jpg",".jpeg",".gif");
            foreach(${"alowed_".$vari} as $ext) {
                $alowed = false;
                if(strtolower(substr($para,-(strlen($ext)))) == $ext) {
                    $alowed = true;
                    break;
                }
            }
            if(!$alowed)
                return false;

            # $para in cat und file aufspliten (cat:file)
            list($cat,$file) = $CatPage->split_CatPage_fromSyntax($para,true);

            # gibts das file überhaubt
            if($CatPage->exists_File($cat,$file)) {
                # als kompletten pfad richtig kodiert zurück geben
                return $CatPage->get_srcFile($cat,$file,true);
            }
        }
        return false;
    }
    
    /***************************************************************
    * 
    * Gibt die Konfigurationsoptionen als Array zurück.
    * Ist keine Konfiguration nötig, ist dieses Array leer.
    * 
    ***************************************************************/
    function getConfig() {
        // Das muss auf jeden Fall geschehen!
        $config = array();

        $config['skin'] = array(
            "type" => "select",              // Pflicht:  Eingabetyp
            "description" => "Skin/Theme",   // Pflicht:  Beschreibung
            // Pflicht:  Beschreibung der einzelnen Auswahlmöglichkeiten
            "descriptions" => array(
                ""       => "no skin",      // Anzeige => Speicherung in plugin.conf
                "glass"  => "glass",
                "black"  => "black",
                "corner" => "corner",
                "round"  => "round"
                ),
            "multiple" => "false"            // optional: Mehrfachauswahl erlauben
        ); 

        $config['defaultWidth']  = array(
            "type" => "text",                               // Pflicht:  Eingabetyp
            "description" => 'Default-Breite (inkl. "px" oder "%")',  // Pflicht:  Beschreibung
            "maxlength" => "6",                             // optional: maximale Länge
            "size" => "10",                                 // optional: dargestellte Zeichen
            "regex" => "/^\d+[%|px]{1,2}$/",                // optional: Erlaubte Werte als regulärer Ausdruck (hier: drei kleine Buchstaben; wird beim Speichern der Einstellungen überprüft)
            "regex_error" => "\"%\" oder \"px\" müssen mit angegeben werden!" // optional: Fehlermeldung für die RegEx-Überprüfung
        );

        $config['defaultHeight']  = array(
            "type" => "text",                             // Pflicht:  Eingabetyp
            "description" => 'Default-Höhe (inkl. "px" oder "%")',  // Pflicht:  Beschreibung
            "maxlength" => "6",                           // optional: maximale Länge
            "size" => "10",                               // optional: dargestellte Zeichen
            "regex" => "/^\d+[%|px]{1,2}$/",              // optional: Erlaubte Werte als regulärer Ausdruck (hier: drei kleine Buchstaben; wird beim Speichern der Einstellungen überprüft)
            "regex_error" => '"%" oder "px" müssen mit angegeben werden!' // optional: Fehlermeldung für die RegEx-Überprüfung
        );

        return $config;
    } // function getConfig
    
    
    /***************************************************************
    * 
    * Gibt die Plugin-Infos als Array zurück - in dieser 
    * Reihenfolge:
    *   - Name des Plugins
    *   - Version des Plugins
    *   - Kurzbeschreibung
    *   - Name des Autors
    *   - Download-URL
    * 
    ***************************************************************/
    function getInfo() {
        return array(
            // Plugin-Name
            "<b>FlayrPlayer</b> Revision: 155",
            // CMS-Version
            "2.0",
            // Kurzbeschreibung
            'Plugin erzeugt den FlayrPlayer, einen freien (http://www.flayr.net, Lizenz beachten - Namensnennung!) Flash-Player für die Wiedergabe von .flv, .f4v und .mp4 Dateien.
            Das <span style="font-weight:bold;">Aussehen des Players</span> kann hier unten in der Plugin-Conf. durch Auswahl eines <span style="font-weight:bold;">Skin/Theme</span> geändert werden.<br />
            <br />
            <br />
            Grundsätzlicher Aufruf im CMS (Parameter-Reihenfolge muss eingehalten werden!):<br />
            <br />
            <span style="font-weight:bold;">{FlayrPlayer|<span style="font:italic;">Videodatei,Vorschaubild,Videobreite,Videohöhe</span>}</span><br />
            <br />
            <br />
            -------------------------------------------------<br />
            <span style="font:italic; font-weight:bold;">Videodatei</span> (Pflicht) kann sein - Beispiele:<br />
            -------------------------------------------------<br />
            video.mp4 -> Datei aus aktueller Kategorie <span style="font-weight:bold;">(Dateidropdown!)</span><br />
            Willkommen:clip.flv -> Datei clip.flv aus Kategorie Willkommen <span style="font-weight:bold;">(Dateidropdown!)</span><br />
            http://www.example.com/video.flv -> Externe Datei (http://, https://) <br />
            Erlaubte Dateiendungen .flv, .f4v, .mp4<br />
            <br />
            ------------------------------------------------------<br />
            <span style="font:italic; font-weight:bold;">Vorschaubild</span> (optional) kann sein - Beispiele:<br />
            ------------------------------------------------------<br />
            preview.jpg -> Datei aus aktueller Kategorie <span style="font-weight:bold;">(Dateidropdown!)</span><br />
            Willkommen:image.jpg -> Datei image.jpg aus Kategorie Willkommen <span style="font-weight:bold;">(Dateidropdown!)</span><br />
            http://www.example.com/image.jpg -> Externe Datei<br />
            Erlaubte Dateiendungen .png, .jpg, .jpeg, .gif<br />
            <br />
            -------------------------------------<br />
            <span style="font:italic; font-weight:bold;">Videobreite/-höhe</span> (optional):<br />
            -------------------------------------<br />
            Wenn die Videogröße nicht explizit im Pluginaufruf angegeben wird, wird der default-Wert aus Plugin-Conf (siehe unten) verwendet.<br />
            Wird die Höhe in Px angegeben, ist der erzeugte Player autom. um 25 Px höher als die angegebene Videohöhe, damit das Video nicht gestaucht wird, da dies die Höhe der Playerleiste ist.<br />
            Wird beim Plugin-Aufruf nicht angegeben, ob es sich um "px" oder "%" handelt, wird autom. px verwendet.<br />
            <br />',
            // Name des Autors
            "hausl78",
            // Download-URL
            "https://www.mozilo.de/",
        array('{FlayrPlayer|}' => 'Videodatei,VorschauBild,Breite,Höhe')
            );
    } // function getInfo

} // class

?>